<?
function cldie($errormsg) {
 echo ($errormsg);
 exit (201);
}
class ChangeHelper {
 var $m_change = null;
 



 function ChangeHelper($change) {
 $this->m_change = $change;
 }

 function getDate() {
 return $this->m_change["date"];
 }
 function getBuild() {
 return $this->m_change["inbuild"];
 }
 function getReporter() {
 return $this->m_change["reporter"];
 }
 function getText() {
 return $this->m_change["text"];
 }
 function getType() {
 return $this->m_change["type"];
 }
 function getDirective() {
 return $this->m_change["directive"];
 }
 function getDescription() {
 return $this->m_change["description"];
 }
}

class ChangelogExecutor {
 




 var $logLevel = 0;

 var $errors = array ();
 var $warnings = array ();
 var $infos = array ();

 function error($text) {
 $this->errors[] = $text;
 }

 function warning($text) {
 $this->warnings[] = $text;
 }

 function info($text) {
 $this->infos[] = $text;
 }

 function clearOutput() {
 $this->errors = array ();
 $this->warnings = array ();
 $this->infos = array ();
 }

 function printOutput($prefix, $arr) {
 $ret = "";
 foreach ($arr as $out) {
 $ret .= $prefix . "  " . $out . "\n";
 }
 return $ret;
 }

 function printDebugOutput($change, $debugLevel) {
 $out = "";

 if ($debugLevel >= 3)
 $out .= $this->printOutput("INFO:   ", $this->infos);
 if ($debugLevel >= 2)
 $out .= $this->printOutput("WARNING:", $this->warnings);
 if ($debugLevel >= 1)
 $out .= $this->printOutput("ERROR:  ", $this->errors);

 if ($out) {
 echo "----------------------- DEBUG ---------------------------\n";
 echo $out;
 echo "--------------------- END DEBUG -------------------------\n";

 }
 }

 









 function execute($change) {
 }
}

class SQLExecutor extends ChangelogExecutor {

 function getID() {
 return "SQL";
 }

 function connectDB($directive) {
 global $UPDATE_ROOT;
 static $dbConnects = array ();

 $handles = array ();

 if (strlen($directive) > 0) {
 $mydb = explode(".", $directive);
 $this->info("DB is " . $mydb[0]);
 switch ($mydb[0]) {
 case "node" :
 global $DB, $SETTINGS;
 $DB = mydb_connect($SETTINGS["db"], $SETTINGS["server"], $SETTINGS["login"], $SETTINGS["pw"]);
 return $DB;
 case "tracking" :
 global $TN_DB_SETTINGS;
 $dbsettings = $TN_DB_SETTINGS[$mydb[1]];
 break;
 case "portal" :
 global $PN_DB_SETTINGS;
 $dbsettings = $PN_DB_SETTINGS;
 break;
 case "contentmap" :
 global $CN_MAP_DB_SETTINGS;
 global $FEATURE;
 global $CN_MAP_DBS;

 if ($FEATURE["contentmap_handles"]) {
 $dbsettings = $CN_MAP_DBS;
 $multi_handles = true;
 } else
 $dbsettings = $CN_MAP_DB_SETTINGS;

 break;
 }

 
 if ($multi_handles) {
 while (list ($name, $db) = each($dbsettings)) {
 if ($db["map"]) {
 $server = $db["map"]["server"];
 $dbtype = $db["map"]["dbtype"];
 $db = $db["map"]["db"];
 $login = $db["map"]["login"];
 $password = $db["map"]["pw"];
 }
 $this->info("DBSETTINGS (contentmap $name):" .
 " server($server) type($dbtype) db($db) login($login) password($password)");

 
 if (isset ($dbConnects[$server][$db]) && false) {
 $this->info("DBSETTINGS: cached.");
 return $dbConnects[$server][$db];
 }

 if ($dbtype == "ora")
 $_dbtype = "oracle";
 else
 $_dbtype = $dbtype;
 include_once ("$UPDATE_ROOT/lib/db/" . $_dbtype . ".func.php");
 $handle = mydb_connect($db, $server, $login, $password, $dbtype);
 $dbConnects[$server][$db] = $handle;

 $handles[] = $handle;
 }
 } else {
 if ($dbsettings) {
 $server = $dbsettings["server"];
 $dbtype = $dbsettings["dbtype"];
 $db = $dbsettings["db"];
 $login = $dbsettings["login"];
 $password = $dbsettings["pw"];
 }
 $this->info("DBSETTINGS: server($server) type($dbtype) db($db) login($login) password($password)");
 
 if (isset ($dbConnects[$server][$db]) && false) {
 $this->info("DBSETTINGS: cached.");
 return $dbConnects[$server][$db];
 }

 if ($dbtype == "ora")
 $_dbtype = "oracle";
 else
 $_dbtype = $dbtype;
 include_once ("$UPDATE_ROOT/lib/db/" . $_dbtype . ".func.php");
 $handle = mydb_connect($db, $server, $login, $password, $dbtype);
 $dbConnects[$server][$db] = $handle;

 $handles[] = $handle;
 }

 return $handles;
 } else {
 $this->info("using default DB-handle");
 global $DB, $SETTINGS;
 $DB = mydb_connect($SETTINGS["db"], $SETTINGS["server"], $SETTINGS["login"], $SETTINGS["pw"]);
 $handles[] = $DB;
 return $handles;
 }
 }

 function execute($change) {
 $changeHelper = new ChangeHelper($change);
 $mydbs = $this->connectDB($changeHelper->getDirective());

 $preparsed = $changeHelper->getText();
 $preparsed = str_replace("\\;", "@@GTXDELIM@@", $preparsed);
 $sqls = explode(";", $preparsed);
 $ret = true;

 foreach ($mydbs as $mydb) {
 foreach ($sqls as $sql) {
 
 $sql = str_replace("@@GTXDELIM@@", ";", $sql);
 $sql = trim($sql);
 if ($sql) {
 $res = query($sql, $mydb); 
 $ret &= $res;
 if ($res)
 $this->info("SUCCESS; SQL: " . $sql);
 else {
 $this->error("SQL: " . $sql);
 $this->error("mysql says: " . mysql_error($mydb["handle"]));
 }
 }
 }
 }
 return $ret;
 }
}

class SQLCreateExecutor extends SQLExecutor {

 function getID() {
 return "SQLCREATE";
 }

 function findCreateStatement($db, $table) {
 global $CURRENT_MODULE_NAME, $SETTINGS;

 $fp = fopen("./modules/${CURRENT_MODULE_NAME}/sql/$db." . $SETTINGS["dbtype"] . ".sql", "r");
 if (!$fp)
 return false;

 $stmt = "";
 $found = false;
 $str = fgets($fp, 4096);
 while ($str !== false) {
 if (!$found) {
 if (preg_match("/create[ \\t]+table[ \\t]+$table( |\(|$)/i", $str)) {
 $found = true;
 $stmt = $str;
 }
 } else {
 $stmt .= $str;
 if (strpos($str, ";") !== false) {
 fclose($fp);
 return trim($stmt);
 }
 }
 $str = fgets($fp, 4096);
 }

 fclose($fp);
 return false;
 }

 function execute($change) {
 $changeHelper = new ChangeHelper($change);
 $mydb = $this->connectDB($changeHelper->getDirective());

 global $SETTINGS, $DB;

 $c = preg_match("/(.*)\.(.*)/", $change["text"], $matches);
 if (!$c) {
 $this->error("Could not split " . $change["text"] . "!");
 return false;
 }

 if ($matches[1] != "node") {
 $this->error("Only node.* supported!");
 return false;
 }

 $sql = $this->findCreateStatement($matches[1], $matches[2]);
 if ($sql === false) {
 $this->error("Could not find create Statement for $matches[1].$matches[2]!");
 return false;
 }
 $res = query($sql, $mydb); 

 if ($res)
 $this->info("SQL: " . $sql);
 else {
 $this->error("SQL: " . $sql);
 $this->error("mysql says: " . mysql_error($DB["handle"]));
 }

 return $res ? true : false;
 }
}

class CommentExecutor extends ChangelogExecutor {
 function getID() {
 return "COMMENT";
 }

 function execute($change) {
 return true;
 }
}

class FeatureExecutor extends ChangelogExecutor {
 function getID() {
 return "FEATURE";
 }

 function execute($change) {
 global $CONFIG_FILE;
 $changeHelper = new ChangeHelper($change);
 $fp = fopen($CONFIG_FILE, "r");
 if (!$fp)
 return false;

 if (!preg_match("/([^=]*)=([^=]*)/", $change["text"], $matches)) {
 return false;
 }
 $feature = $matches[1];
 $default = $matches[2];

 $preconfig = "";
 $pastconfig = "";
 $config = & $preconfig;
 $positionFound = false;

 $str = fgets($fp, 4096);
 while ($str !== false) {
 $ignoreLine = false;
 if (preg_match("/.*\\\$FEATURE *\\[ *\"$feature\"\\ *]/", $str)) {
 if ($changeHelper->getDirective() == "force") {
 $ignoreLine = true;
 $this->info("FEATURE found, but set forced by directive");
 } else {
 $this->info("FEATURE already there....");
 fclose($fp);
 return true;
 }
 }
 if (!$ignoreLine)
 $config .= $str;
 if (preg_match("/.*##AUTO-FEATURES##.*/", $str)) {
 $config = & $pastconfig;
 $positionFound = true;
 }
 $str = fgets($fp, 4096);
 }
 fclose($fp);
 
 if (!$positionFound)
 return false;

 $fp = fopen($CONFIG_FILE, "w");
 if (!$fp)
 return false;
 fwrite($fp, $preconfig .
 "// @FEATURE $feature: " . $change["description"] . "\n" .
 "\$FEATURE[\"$feature\"] = $default;\n" .
 $pastconfig);
 fclose($fp);
 return true;
 }
}

class ScriptExecutor extends ChangelogExecutor {

 function getID() {
 return "SCRIPT";
 }

 function execute($change) {
 global $DBNAME, $CURRENT_MODULE_NAME, $FILEPATH, $ROOT, $CONFIG_FILE, $UPDATE_ROOT;
 $command = "cd ./CHANGELOG/scripts/$CURRENT_MODULE_NAME ; chmod +x  ./" . $change["text"] .
 " ; ./" . $change["text"] . " $DBNAME \"$ROOT\" \"$FILEPATH\" \"$UPDATE_ROOT\" \"$CONFIG_FILE\"";
 $ret = exec($command . " 2>&1", $output, $return_value);
 if ($return_value != 0) {
 $this->info("return value: $return_value");
 if (is_array($output))
 $this->error(implode("\n", $output));
 return false;
 }
 return true;
 }
}

class PhpExecutor extends ChangelogExecutor {

 function getID() {
 return "PHP";
 }

 function execute($change) {

 global $CONFIG_FILE, $UPDATE_ROOT, $CURRENT_MODULE_NAME;
 $command = "/Node/bin/php -q ./changelog_php.php \"$UPDATE_ROOT\" \"$CONFIG_FILE\" \"./CHANGELOG/scripts/$CURRENT_MODULE_NAME/" . $change["text"] . "\"";

 $ret = exec($command . " 2>&1", $output, $return_value);
 if ($return_value != 0) {
 $this->info("return value: $return_value");
 if (is_array($output))
 $this->error(implode("\n", $output));
 return false;
 }
 return true;
 }
}

class CommandExecutor extends ChangelogExecutor {

 function getID() {
 return "COMMAND";
 }

 function execute($change) {
 $ret = system($change["text"]);
 if ($ret) {
 $this->info("return value: $ret");
 }
 return true;
 }
}

$CHANGELOG_EXECUTORS = array (
 new SQLExecutor(),
 new SQLCreateExecutor(),
 new CommentExecutor(),
 new FeatureExecutor(),
 new ScriptExecutor(),
 new PhpExecutor(),
 new CommandExecutor(),
 
);

class Version {
 var $m_vArr = array ();

 function Version($vString) {
 if (substr($vString, 0, 1) == "V")
 $vString = substr($vString, 1);
 $this->m_vArr = explode(".", $vString);
 }

 function getVersionString() {
 return "V" . implode(".", $this->m_vArr);
 }

}



function getTimeDiffDays($seconds) {
 return (int) ($seconds / 86400);
}

function getChangelogString($change, $exec) {
 return date("Y-m-d", $change["date"]) . "\t" . $change["reporter"] . "\t" . $exec->getID() . "\t" . $change["text"] . "\t##\t" . $change["description"];
}

function findChangeLogType($str) {
 global $CHANGELOG_EXECUTORS;

 foreach ($CHANGELOG_EXECUTORS as $exec) {
 list ($str, $global) = split(":", $str);
 $isGlobal = ($global == "global");
 if (strtolower($exec->getID()) == strtolower($str))
 return array (
 "type" => $exec,
 "global" => $isGlobal
 );
 }
 return null;
}

function splitDirective($changelogStr) {
 if (preg_match("/^@([A-Za-z0-9.= ]*):(.*)/i", trim($changelogStr), $matches)) {
 return array (
 "directive" => trim($matches[1]),
 "text" => trim($matches[2])
 );
 } else
 return array (
 "directive" => "",
 "text" => $changelogStr
 );
}















function parseChangeLogLine($line) {
 $field = "([^\\t ]*)[\\t ]*"; 

 $found = preg_match("/$field$field$field$field(.*)/i", $line, $matches);
 
 if ($found < 1) {
 return false;
 }


 $datestr = trim($matches[1]);
 
 if (!preg_match("/[0-9]{4}-[0-9]{2}-[0-9]{2}/", $datestr)) {
 return false;
 }
 

 $date = mktime(0, 0, 0, substr($datestr, 5, 2), substr($datestr, 8, 2), substr($datestr, 0, 4));
 
 
 if (isNewChangelogMechanism(trim($matches[2]))) {
 $inbuild = trim($matches[2]);
 } 

 $reporter = trim($matches[3]);

 $typeStr = strToLower(trim($matches[4]));
 $type = findChangeLogType($typeStr);

 $hasComment = preg_match("/(.*)##(.*)/", $matches[5], $textmatch);
 if ($hasComment) {
 $text = trim($textmatch[1]);
 $desc = trim($textmatch[2]);
 } else {
 $text = trim($matches[5]);
 }
 
 $directiveText = splitDirective($text);
 return array (
 "date" => $date,
 "inbuild" => $inbuild,
 "reporter" => $reporter,
 "type" => $type["type"],
 "global" => $type["global"],
 "text" => $directiveText["text"],
 "directive" => $directiveText["directive"],
 "description" => $desc
 );
}




















function parseChangeLog($filename, $sinceBuild) {
 $f = fopen($filename, "r");
 if (!$f)
 return false;

 $chlog = array ();
 $str = fgets($f, 4096);
 
 while (($str = fgets($f, 4096)) !== false) {
 $trimmed = trim($str);
 
 
 if (strlen($trimmed) <= 0) {
 continue;
 }
 
 
 if (substr($trimmed, 0, 1) == "#") {
 continue;
 }
 $next = parseChangeLogLine($trimmed);

 
 if (!$next) {
 $chlog[] = array (
 "type" => null,
 "str" => $str
 );
 } else {
 
 if (isNewChangelogMechanism($next["inbuild"])) {
 if ( !isChangeApplied($next["inbuild"])) {
 
 if ($next["type"] === null) {
 $chlog[] = array (
 "type" => null,
 "str" => $str
 );
 } else {
 
 $chlog[] = $next;
 }
 }
 
 
 } else if($next['date'] > $sinceBuild) {
 $chlog[] = array (
 "type" => null,
 "str" => $str
 );
 }
 } 
 
 }
 fclose($f);
 return $chlog;
}










function executeChangelog($chlog, $doexec, $doexecGlobal, $info = "", $debugLevel = 0, $build = '') {
 global $FILEPATH;

 $infoWritten = false;
 $errorcount = 0;

 foreach ($chlog as $change) {
 
 if (!$infoWritten) {
 echo $info;
 $infoWritten = true;
 }
 
 if ($change["type"] !== null) {
 if (!$change["global"] || $doexecGlobal) {
 $exec = $change["type"];
 $exec->clearOutput();
 if ($doexec) {
 $start = getCurrentTimeMS();
 $ret = $exec->execute($change);
 $duration = getCurrentTimeMS() - $start;
 if ($ret) {
 
 if (isNewChangelogMechanism($change["inbuild"])) {
 query("INSERT INTO changelog_applied (id, timestamp, build, duration) VALUES ('" . sqlslashes($change["inbuild"]) . "', unix_timestamp(), '" . sqlslashes($build) . "', " . (int) $duration . ")");
 }
 echo "SUCCESS: ";
 } else {
 echo "FAILED:  ";
 $errorcount++;
 }
 } else {
 echo "INFO:    ";
 }

 echo getChangelogString($change, $exec) . "\n";
 $exec->printDebugOutput($change, $debugLevel);
 }
 } else {
 echo "UNKNOWN: " . $change["str"];
 }
 }

 return $errorcount;
}






function isNewChangelogMechanism($number) {
 return substr($number, 0, 3) == 'CH-';
}






function isChangeApplied($number) {
 $rs = query("SELECT id FROM changelog_applied WHERE id = '" . sqlslashes($number) . "'");
 return $rs["num"] > 0;
}





function getCurrentTimeMS() {
 list ($usec, $sec) = explode(" ", microtime());
 return $sec * 1000 + (int) ($usec * 1000);
}











function checkApplicability($modules) {
 
 $res = query("SELECT id FROM changelog_applied");
 if ($res["num"] === 0) {
 return;
 }
 
 
 $applied = array();
 while (list($k,$v) = each($res["arr"])) {
 $applied[$v["id"]] = true;
 }
 
 
 foreach ($modules as $module) {
 $chlog = file("./CHANGELOG/$module.CHANGELOG");
 while (list($k, $line) = each($chlog)) {
 if (preg_match("/(CH-\d+)/", $line, $matches)) {
 
 unset($applied[$matches[1]]);
 }
 }
 }
 
 
 if (count($applied) > 0) {
 halt(1, "The changelog is missing changes that have already been applied to the system. "
 . "It seems you are trying to downgrade to an older version of Gentics Content.Node that is not compatible. " 
 . "Missing changes are: " . implode(", ", array_keys($applied)));
 exit(1);
 }
}

if ($argc < 5) {
 echo "USAGE: changelog.php <modulename> <configfile> <root> <update_root> <doexec> <execglobal> [<debuglevel>]\n\n";
 echo "       root      : /Node/.node\n";
 echo "       doexec    : noexec, exec\n";
 echo "       execglobal: noglobals, globals\n";
 echo "       debuglevel: 0-3 (default:0:none, 1:errors, 2:warnings, 3:infos)\n";
 die;
}
$MODULE_NAMES = $argv[1];
$CONFIG_FILE = $argv[2];
$ROOT = $argv[3];
$UPDATE_ROOT = $argv[4];
$DOEXEC = strtolower($argv[5]) == "exec";
$DOEXECGLOBAL = strtolower($argv[6]) == "globals";
if (isset ($argv[7]))
 $DEBUG_LEVEL = $argv[7];
else
 $DEBUG_LEVEL = 0;


$GLOBAL_MODULES = array (
 "portal",
 "tracking"
);


function halt($id, $text) {
 echo "HALT called: id($id), text: $text\n\n";
}
$HALT = true;

require_once ($CONFIG_FILE);
include ("$UPDATE_ROOT/lib/misc/calctime.func.php");
include ("$UPDATE_ROOT/lib/str/version.func.php");
include ("$UPDATE_ROOT/lib/db/cache.func.php");
include ("$UPDATE_ROOT/lib/db/db.func.php");
include ("$UPDATE_ROOT/lib/db/query.func.php");
include ("$UPDATE_ROOT/lib/str/slashes.func.php");
include_once ("$UPDATE_ROOT/lib/db/" . $SETTINGS["dbtype"] . ".func.php");

if ($DEBUG_LEVEL > 0) {
 echo "DEBUG is on. Level: $DEBUG_LEVEL\n";
 echo "----------------------------------\n";
 echo "INFO: modules     : $MODULE_NAMES\n";
 echo "INFO: config      : $CONFIG_FILE\n";
 echo "INFO: root        : $ROOT\n";
 echo "INFO: update-root : $UPDATE_ROOT\n";
 echo "INFO: exec        : $DOEXEC (changelog will " . ($DOEXEC ? "" : "NOT ") . "be executed)\n";
 echo "INFO: global      : $DOEXECGLOBAL (globals will " . ($DOEXECGLOBAL ? "" : "NOT ") . "be executed)\n";
 echo "INFO: FILEPATH    : $FILEPATH\n";
 echo "----------------------------------\n\n";
}


$DBNAME = $SETTINGS["db"];
$DB = mydb_connect($SETTINGS["db"], $SETTINGS["server"], $SETTINGS["login"], $SETTINGS["pw"]);


$rs = query("show tables like 'changelog_applied'");
if ($rs["num"] == 0) {
 
 query("create table changelog_applied (id varchar(10) not null primary key, timestamp int not null default 0, build varchar(255) not null default '', duration int not null default 0)");
}

$modules = explode(";", $MODULE_NAMES);

chdir($UPDATE_ROOT);


checkApplicability($modules);

$totalerrors = 0;

foreach ($modules as $CURRENT_MODULE_NAME) {
 if (strlen(trim($CURRENT_MODULE_NAME)) > 0) {
 
 $chlog = parseChangeLog("./CHANGELOG/$CURRENT_MODULE_NAME.CHANGELOG", 1293892234);
 if ($chlog === false)
 cldie("ERROR: error parsing changelog $CURRENT_MODULE_NAME\n");

 
 if (!in_array($CURRENT_MODULE_NAME, $GLOBAL_MODULES) || $DOEXECGLOBAL) {
 $errors = executeChangelog($chlog, $DOEXEC, $DOEXECGLOBAL, "\nMODULE : $CURRENT_MODULE_NAME\n", $DEBUG_LEVEL);
 if ($errors) {
 $totalerrors += $errors;
 echo "ERROR: some errors occured while executing the changelog!\n";
 }
 }
 }
}

if ($totalerrors) {
 
 if ($totalerrors > 200)
 $totalerrors = 254;
 exit ($totalerrors);
}
?>