<?

class ItemListDictionaryDataSource extends ItemListActionDataSource {

 var $languages;
 var $user;
 var $sortCol;
 var $sortWay;
 var $sorted;
 
 var $search;
 var $exact;
 var $field;
 var $translation;
 var $module;
 var $inuse;
 var $editlink;

 var $cprefix = "lang";

 function ItemListDictionaryDataSource($languages, $user = false) {
 $this->languages = $languages;
 $this->user = $user;
 $this->exact = false;
 $this->search = "";
 $this->field = false;
 $this->translation = false;
 $this->module = false;
 $this->inuse = false;
 $this->sortCol = "id";
 $this->sortWay = "ASC";
 $this->sorted = true;
 }

 function setEditLink($link) {
 $this->editlink = $link;
 }

 function getEditLink() {
 return $this->editlink;
 }

 function setSearch($val) {
 $this->search = ($val)?$val:"";
 }

 function getSearch() {
 return $this->search;
 }

 function setField($field) {
 if (!$field) $field = false;
 $this->field = $field;
 }

 function getField($field) {
 return $this->field;
 }
 
 function setExactMatch($val) {
 $this->exact = ($val)?true:false;
 }

 function getExactMatch() {
 return $this->exact;
 }

 function setTranslation($val) {
 if (!$val) $val = false;
 $this->translation = $val;
 }

 function getTranslation() {
 return $this->translation;
 }

 function setModule($val) {
 if ($val == "all" || $val == "") $val = false;
 $this->module = $val;
 }

 function getModule() {
 return $this->module;
 }

 function setInUse($val) {
 $this->inuse = $val;
 }

 function getInUse() {
 return $this->inuse;
 }

 function getPlainResultSet( $fromIdx, $toIdx, &$count, $search = "", $fetchAll = false ) {
 global $METALANGUAGE_ID, $DIC_TYPE, $DB;
 
 $db = ($this->user)?$DB:getDicDBHandle();
 $dic = ($this->user)?"dicuser":"dic";
 $output = ($this->user)?"outputuser":"output";
 
 $select = "";
 $from = "$output";
 reset($this->languages);
 while (list($key,$val) = each($this->languages)) {
 if ( $key ) {
 $col = sqlf_table($this->cprefix.$key);
 $select .= ",$col.value AS $col";
 $from .= " LEFT JOIN $dic ".sqlas()." $col ON $output.id = $col.output_id AND $col.language_id = ".sqlf_tl_num($key);
 }
 }
 $select .= ",$output.info";
 
 $sql = "SELECT $output.id$select FROM $from";
 $csql = "SELECT count($output.id) AS c FROM $from";

 $where = "";
 if ($this->inuse) {
 if ($where) $where .= " AND ";
 $where .= "$output.enabled = ".($this->inuse == 1?1:0);
 }

 if (!is_false($this->module)) {
 if ($where) $where .= " AND ";
 $where .= "$output.info = ".sqlf_tl_num($this->module);
 }

 if ($this->search) {
 if ($where) $where .= " AND ";
 if ($this->exact) {
 $search = "= \"".sqlslashes($this->search)."\"";
 } else {
 $search = "LIKE \"%".sqlslashes($this->search)."%\"";
 }

 if (is_false($this->field)) {
 $where .= "($output.id $search";
 reset($this->languages);
 while (list($key,$val) = each($this->languages)) {
 if ( $key )
 $where .= " OR ".sqlf_table($this->cprefix.$key).".value ".$search;
 }
 $where .= ")";
 } else if ($this->field == "id") {
 $where .= "$output.id $search";
 } else {
 $where .= sqlf_table($this->cprefix.$this->field).".value ".$search;
 }
 }

 if ($this->translation) {
 $_where = "";
 switch ($this->translation) {
 case "full":
 reset($this->languages);
 while (list($key,$val) = each($this->languages)) {
 if ($key == $METALANGUAGE_ID) continue;
 if ( !$key ) continue;
 if ($_where) $_where .= " AND ";
 $_where .= sqlf_table($this->cprefix.$key).".value != \"\"";
 }
 if ($_where) $_where = "($_where)";
 break;
 case "part":
 reset($this->languages);
 while (list($key,$val) = each($this->languages)) {
 if ($key == $METALANGUAGE_ID) continue;
 if (!$key ) continue;
 if ($_where) $_where .= " OR ";
 $field = sqlf_table($this->cprefix.$key).".value";
 $_where .= "($field = \"\" OR $field IS NULL)";
 }
 if ($_where) $_where = "($_where)";
 break;
 case "new":
 reset($this->languages);
 while (list($key,$val) = each($this->languages)) {
 if ($key == $METALANGUAGE_ID) continue;
 if (!$key) continue;
 if ($_where) $_where .= " AND ";
 $field = sqlf_table($this->cprefix.$key).".value";
 $_where .= "($field = \"\" OR $field IS NULL)";
 }
 if ($_where) $_where = "($_where)";
 break;
 default:
 $id = (int) $this->translation;
 if ($this->languages[$id]) {
 $field = sqlf_table($this->cprefix.$id).".value";
 $_where = "($field = \"\" OR $field IS NULL)";
 }
 }
 if ($_where) {
 if ($where) $where .= " AND ";
 $where .= $_where;
 }
 }

 if ($where) {
 $sql .= " WHERE $where";
 $csql .= " WHERE $where";
 }

 if ($this->sorted) {
 $sql .= " ORDER BY ".sqlf_name($this->sortCol)." ".sqlf_name($this->sortWay);
 }

 $rs = query($csql,true,0,$db);
 $count = $rs["arr"][0]["c"];

 $limit = array($fromIdx, $toIdx - $fromIdx + 1);
 $rs = query($sql, false, $limit,$db);

 $res = array();
 while (list($key,$val) = each($rs["arr"])) {
 if (!$val[$this->cprefix.$METALANGUAGE_ID]) $val[$this->cprefix.$METALANGUAGE_ID] = " - ";
 $val["info"] = $DIC_TYPE[$val["info"]];
 if ($this->editlink) $val["id"] = "<a href=\"".$this->editlink."&id=".$val["id"]."\">".$val["id"]."</a>";
 $res[] = $val;
 }
 
 return $res;
 }

 function isSearchable() {
 return false;
 }

 function getKey() { 
 return "DicAdmin";
 }

 function setSort( $column, $way ) {
 $this->sortCol = $column;
 $this->sortWay = $way;
 $this->sorted = true;
 }

 function getCurrentSort( &$column, &$way ) {
 if (!$this->sorted) return false;
 $column = $this->sortCol;
 $way = $this->sortWay;
 return true;
 }

 function getSortWays( $column ) {
 global $ICO_SORT_ASC, $ICO_SORT_DESC;
 return array(
 array("way"=>"ASC", "icon"=>$ICO_SORT_ASC),
 array("way"=>"DESC", "icon"=>$ICO_SORT_DESC)
 );
 }

 function getColumns() {
 $rs = array("id");
 reset($this->languages);
 while (list($key, $val) = each($this->languages)) {
 $rs[] = $this->cprefix.$key;
 }
 $rs[] = "info";
 return $rs;
 }

 function hasColumnHeaders() {
 return true;
 }

 function getColumnHeader( $column ) {
 switch ($column) {
 case "id": $rs = "ID"; break;
 case "info": $rs = "Module"; break;
 default:
 $key = substr($column, strlen($this->cprefix));
 $rs = $this->languages[$key];
 }
 return $rs;
 }

}

class ILDSLanguage extends ItemListActionDataSource {
 
 var $sortCol;
 var $sortWay;
 var $link;
 
 function ILDSLanguage() {
 $this->sortCol = "id";
 $this->sortWay = "ASC";
 $this->link = "";
 }

 function getPlainResultSet($from, $to, &$count, $search = "", $fetchAll = false) {
 global $METALANGUAGE_ID, $DIC_LANGUAGES;
 
 $sql = "SELECT id, name FROM language ORDER BY ".sqlf_order_field($this->sortCol)." ".sqlf_order_way($this->sortWay);
 $rs = query($sql);
 
 $res = array();
 while (list($key,$val) = each($rs["arr"])) {
 if ($this->link) $val["name"] = "<a href=\"".$this->link.$val["id"]."\">".$val["name"]."</a>";
 if ($DIC_LANGUAGES[$val["id"]]) $val["active"] = "Yes";
 $res[] = $val;
 }

 return $res;
 }
 
 function isSearchable() {
 return false;
 }

 function getKey() { 
 return "DicLanguages";
 }

 function setSort( $column, $way ) {
 $this->sortCol = $column;
 $this->sortWay = $way;
 }

 function getCurrentSort( &$column, &$way ) {
 $column = $this->sortCol;
 $way = $this->sortWay;
 return true;
 }

 function getSortWays( $column ) {
 global $ICO_SORT_ASC, $ICO_SORT_DESC;
 if ($column == "active") return false;
 return array(
 array("way"=>"ASC", "icon"=>$ICO_SORT_ASC),
 array("way"=>"DESC", "icon"=>$ICO_SORT_DESC)
 );
 }

 function getColumns() {
 $rs = array("id","name","active");
 return $rs;
 }

 function hasColumnHeaders() {
 return true;
 }

 function getColumnHeader( $column ) {
 switch ($column) {
 case "id": $rs = "ID"; break;
 case "name": $rs = "Language"; break;
 case "active": $rs = "Show"; break;
 }
 return $rs;
 }

}

class DicActivateAction extends ItemListAction {

 function DicActivateAction() {
 }

 function getCommandName() {
 return "activate";
 }

 function getDescription() {
 return "Activate";
 }

 function getIconTag() {
 return "";
 }

 function performAction( $listID ) {
 global $METALANGUAGE_ID, $DIC_LANGUAGES;
 
 reset($listID);
 while (list($key,$id) = each($listID)) {
 if (!$DIC_LANGUAGES[$id]) {
 $sql = "SELECT name FROM language WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $DIC_LANGUAGES[$id] = $rs["arr"][0]["name"];
 }
 }
 }
}

class DicDeactivateAction extends ItemListAction {

 function DicDeactivateAction() {
 }

 function getCommandName() {
 return "deactivate";
 }

 function getDescription() {
 return "Deactivate";
 }

 function getIconTag() {
 return "";
 }

 function performAction( $listID ) {
 global $METALANGUAGE_ID, $DIC_LANGUAGES;
 
 reset($listID);
 while (list($key,$id) = each($listID)) {
 if ($id != $METALANGUAGE_ID) {
 unset($DIC_LANGUAGES[$id]);
 }
 }
 }
}


?>
